<?php
header('Access-Control-Allow-Origin: *');
require_once __DIR__ . '/../negocio/Garita.clase.php';
require_once __DIR__ . '/../util/Funciones.clase.php';
date_default_timezone_set("America/Lima");

if (
    !isset($_POST["p_dni"])
    || !isset($_POST["p_conductor"])
    || !isset($_POST["p_placa"])
    || !isset($_POST["p_cat_tip_vehi"])
    || !isset($_POST["p_pertenece"])
    || !isset($_POST["p_dirige"])
    || !isset($_POST["p_caseta"])
    || !isset($_POST["p_cod_usuario"])
    ) {
    Funciones::imprimeJSON(500, "Faltan parametros", "");
    exit();
}

try {
    $obj = new Garita();
    $hora = date("H:i:s");
    $fecha = date('Y-m-d');
    $tipo = 'E';
    $dni = trim($_POST["p_dni"]);
    
    $nombre_conductor = $_POST["p_conductor"];
    if ($nombre_conductor == "CONDUCTOR NO ENCONTRADO" || $nombre_conductor == null || $nombre_conductor == "" || empty($nombre_conductor) ){
        $nombre_conductor = "CONDUCTOR NO ENCONTRADO";
    }
  
    
    $placa = $_POST["p_placa"];
    $cod_tipo_vehi = $_POST["p_cat_tip_vehi"];
    $pertenece = $_POST["p_pertenece"];
    $dirige = $_POST["p_dirige"];
    $caseta = $_POST["p_caseta"];
    $cod_usu = $_POST["p_cod_usuario"];
    $punto_control = "-";
    if (isset($_POST["p_tipo"])) {
        $punto_control = $_POST["p_tipo"];
    }
    $codigo_ruta = 0;
    if (isset($_POST["p_ruta"])) {
        $codigo_ruta = $_POST["p_ruta"];
    }

    $codigo_proveedor = "0";
    if(isset($_POST["p_codigo_proveedor"])){
        $codigo_proveedor = $_POST["p_codigo_proveedor"];
    }

    $codigo_ruta_transporte = "0";
    if(isset($_POST["p_codigo_ruta_transporte"])){
        $codigo_ruta_transporte = $_POST["p_codigo_ruta_transporte"];
    }
    
    $exceso = "0";
    if(isset($_POST["p_exceso"])){
        $exceso = $_POST["p_exceso"];
    }
    
    $version = $_POST["p_version"];
    
    $procedencia = $_POST["p_procedencia"];
    $fecha_recibida = $_POST["p_fecha"];
    if ($fecha_recibida == "" || $fecha_recibida == null || empty($fecha_recibida) ){
        $fecha_recibida = $fecha;
    }
    $hora_recibida =  $_POST["p_hora"];
    if ($hora_recibida == "" || $hora_recibida == null ||  empty($hora_recibida) ){
        $hora_recibida = $hora;
    }
    
        
    $id_qr =  $_POST["p_id_qr"];
    if ($id_qr == "" || $id_qr == null ||  empty($id_qr) ){
        $id_qr = 0;
    }
    

    
    if($procedencia == "OFFLINE"){
            $resultado = $obj->agregarEntradaMovil($fecha_recibida, $placa, $hora_recibida, $pertenece, $dni, $cod_usu, $nombre_conductor, $cod_tipo_vehi, $dirige, $caseta, $tipo, $punto_control, $codigo_ruta, $codigo_proveedor, $codigo_ruta_transporte, $exceso, $version, $fecha, $hora, $procedencia, $id_qr);

    }else{
            $resultado = $obj->agregarEntradaMovil($fecha, $placa, $hora, $pertenece, $dni, $cod_usu, $nombre_conductor, $cod_tipo_vehi, $dirige, $caseta, $tipo, $punto_control, $codigo_ruta, $codigo_proveedor, $codigo_ruta_transporte, $exceso, $version, $fecha, $hora, $procedencia, $id_qr);

    }

    
   // $resultado = $obj->agregarEntradaMovil($fecha, $placa, $hora, $pertenece, $dni, $cod_usu, $nombre_conductor, $cod_tipo_vehi, $dirige, $caseta, $tipo, $punto_control, $codigo_ruta, $codigo_proveedor, $codigo_ruta_transporte, $exceso, $version);

    if(isset($_POST["p_descripcion_infraccion"])){
        $desc_inc = $_POST["p_descripcion_infraccion"];
        if(!empty($desc_inc)){
            $resultado = $obj->reportarInfraccion($dni, $cod_usu, $caseta, 'G', $desc_inc);
        }
    }
  
    Funciones::imprimeJSON(200, "Entrada registrada", $resultado);

} catch (Exception $ex) {
    Funciones::imprimeJSON(500, $ex->getMessage(), "");
}
