<?php
header('Access-Control-Allow-Origin: *');
require_once __DIR__ . '/../negocio/Fundo.clase.php';
require_once __DIR__ . '/../util/Funciones.clase.php';

date_default_timezone_set("America/Lima");

if (!isset($_POST["p_dni"])
    || !isset($_POST["p_placa"])
    || !isset($_POST["p_hora_manual"])
    || !isset($_POST["p_nombre_conductor"])
    || !isset($_POST["p_numero_ocupantes"])
    || !isset($_POST["p_numero_asientos"])
    || !isset($_POST["p_codigo_empresa_sesion"])
    || !isset($_POST["p_usuario_sesion"])
    || !isset($_POST["p_procedencia"])
    || !isset($_POST["p_contenedor"])
    || !isset($_POST["p_nombre_empresa"])
    || !isset($_POST["p_fecha_manual"])
    || !isset($_POST["p_codigo_off_line"])
    || !isset($_POST["p_pin"])
    ) {
    Funciones::imprimeJSON(200, "error", "Faltan parametros");
    exit;
}

try {
    $hora_servidor = date("H:i:s");
    $fecha_entrada_fundo = date("Y-m-d");
    $dni = $_POST["p_dni"];
    $placa = $_POST["p_placa"];
    $hora_manual = $_POST["p_hora_manual"];
    $nombre_conductor = $_POST["p_nombre_conductor"];
    $numero_ocupantes = $_POST["p_numero_ocupantes"];
    $numero_asientos = $_POST["p_numero_asientos"];
    $codigo_empresa_sesion = $_POST["p_codigo_empresa_sesion"];
    $codigo_usuario_sesion = $_POST["p_usuario_sesion"];
    $procedencia_fundo = $_POST["p_procedencia"];
    $contenedor_salida = $_POST["p_contenedor"];
    $nombre_empresa = $_POST["p_nombre_empresa"];
    $fecha_manual = $_POST["p_fecha_manual"];
    $codigo_off_line = $_POST["p_codigo_off_line"];
    $pin = $_POST["p_pin"];

    $codigo_maximo = 0;
    if (isset($_POST["p_maximo_codigo"])) {
        $codigo_maximo = $_POST["p_maximo_codigo"];
    }

    if (strlen($placa) > 7){
        Funciones::imprimeJSON(500, "error", "La placa no puede tener más de 7 dígitos");
        exit;
    }

    $codigo_proveedor = 0;
    if(isset($_POST["p_codigo_proveedor"])){
            $codigo_proveedor = $_POST["p_codigo_proveedor"];
    }

    $codigo_ruta_transporte = 0;
    if(isset($_POST["p_codigo_ruta_transporte"])){
            $codigo_ruta_transporte = $_POST["p_codigo_ruta_transporte"];
    }

    $codigo_proveedor_empresa = 0;
    if(isset($_POST["p_codigo_proveedor_empresa"])){
            $codigo_proveedor_empresa = $_POST["p_codigo_proveedor_empresa"];
    }

    $placa = strtoupper($placa);
    $objEntradaFUNDO = new Fundo();
    $resultado = $objEntradaFUNDO->registrarSalida($dni, $placa, $hora_servidor, $nombre_conductor, $numero_ocupantes, $codigo_empresa_sesion, $codigo_usuario_sesion, $numero_asientos, $procedencia_fundo, $contenedor_salida, $nombre_empresa, $hora_manual, $fecha_entrada_fundo, $fecha_manual, $codigo_off_line, $pin, $codigo_maximo, $codigo_proveedor, $codigo_ruta_transporte, $codigo_proveedor_empresa);
    Funciones::imprimeJSON(200, "Salida registrada", $resultado);
} catch (Exception $ex) {
    Funciones::imprimeJSON(200, "error", $ex->getMessage());
}
