<?php
require __DIR__.'/../datos/Conexion.clase.php';
require __DIR__ . '/../util/definiciones.php';
date_default_timezone_set("America/Lima");

class Viaje extends Conexion {
    public function sincronizarViaje($viajeTipoDetalle, $viajeEmpleadoDetalle, $viajeDetalle)
    {
        $this->dblink->beginTransaction();
        try {
            $codigo_off_line_consulta = "";
            foreach($viajeDetalle as $viaje){
                $fecha_servidor = date("Y-m-d");
                $hora_servidor = date("H:i:s");
                $codigo_proveedor_empresa = $viaje["codigo_proveedor_empresa"];
                $codigo_proveedor = $viaje["codigo_proveedor"];
                $codigo_empresa = $viaje["codigo_empresa"];
                $codigo_conductor = $viaje["codigo_conductor"];
                $codigo_vehiculo = $viaje["codigo_vehiculo"];
                $codigo_ruta_transporte = $viaje["codigo_ruta_transporte"];
                $estado = $viaje["estado"];
                $codigo_off_line = $viaje["codigo_off_line"];
                $nombre_ruta = $viaje["nombre_ruta"];
                $fecha_registro = $viaje["fecha_registro"];
                $costo = isset($viaje["costo"]) ? $viaje["costo"] : 0;
                $timestamp_servidor = "$fecha_servidor $hora_servidor";

                $codigo_off_line_consulta = $codigo_off_line;

                $sql = "SELECT * from viaje where codigo_off_line = ? and codigo_proveedor_empresa = ?;";
                $sentencia = $this->dblink->prepare($sql);
                $sentencia->bindParam(1,$codigo_off_line);
                $sentencia->bindParam(2,$codigo_proveedor_empresa);
                $sentencia->execute();

                if(!$sentencia->rowCount()){ /**SOLO SI NO SE AGREGÓ EL VIAJE A ESE PROVEEDOR EMPRESA SE AÑADE A LA BD**/
                    /**VERIFICAR CORRELATIVO PARA NUEVO CODIGO VIAJE**/
                    $sql = "SELECT numero + 1 as nc from correlativo_control where tabla = 'viaje';";
                    $sentencia = $this->dblink->prepare($sql);
                    $sentencia->execute();

                    if (!$sentencia->rowCount()) {
                        $sql = "INSERT into correlativo_control(numero, tabla) values(0, 'viaje');";
                        $sentencia = $this->dblink->prepare($sql);
                        $sentencia->execute();
                        $codigo_viaje = 1;
                    } else {
                        $resultado = $sentencia->fetch(PDO::FETCH_ASSOC);
                        $codigo_viaje = $resultado["nc"];
                    }
                    /**VERIFICAR CORRELATIVO PARA NUEVO CODIGO VIAJE**/

                    $sql = "INSERT INTO viaje (codigo_viaje,
                                                codigo_proveedor_empresa,
                                                codigo_proveedor,
                                                codigo_empresa,
                                                codigo_conductor,
                                                codigo_vehiculo,
                                                codigo_ruta_transporte,
                                                estado,
                                                codigo_off_line,
                                                nombre_ruta,
                                                fecha_registro_servidor,
                                                fecha_registro_dispositivo,
                                                costo
                                                )
                                        values (:codigo_viaje,
                                                :codigo_proveedor_empresa,
                                                :codigo_proveedor,
                                                :codigo_empresa,
                                                :codigo_conductor,
                                                :codigo_vehiculo,
                                                :codigo_ruta_transporte,
                                                :estado,
                                                :codigo_off_line,
                                                :nombre_ruta,
                                                :fecha_registro_servidor,
                                                :fecha_registro_dispositivo,
                                                :costo
                                                )";
                    $sentencia = $this->dblink->prepare($sql);
                    $sentencia->bindParam(":codigo_viaje", $codigo_viaje);
                    $sentencia->bindParam(":codigo_proveedor_empresa", $codigo_proveedor_empresa);
                    $sentencia->bindParam(":codigo_proveedor", $codigo_proveedor);
                    $sentencia->bindParam(":codigo_empresa", $codigo_empresa);
                    $sentencia->bindParam(":codigo_conductor", $codigo_conductor);
                    $sentencia->bindParam(":codigo_vehiculo", $codigo_vehiculo);
                    $sentencia->bindParam(":codigo_ruta_transporte", $codigo_ruta_transporte);
                    $sentencia->bindParam(":estado", $estado);
                    $sentencia->bindParam(":codigo_off_line", $codigo_off_line);
                    $sentencia->bindParam(":nombre_ruta", $nombre_ruta);
                    $sentencia->bindParam(":fecha_registro_servidor", $timestamp_servidor);
                    $sentencia->bindParam(":fecha_registro_dispositivo", $fecha_registro);
                    $sentencia->bindParam(":costo", $costo);
                    $sentencia->execute();

                    $sql = "UPDATE correlativo_control set numero= numero + 1 where tabla = 'viaje'";
                    $sentencia = $this->dblink->prepare($sql);
                    $sentencia->execute();

                    foreach($viajeTipoDetalle as $viajeTipo){
                        $fecha_servidor_viajeTipo = date("Y-m-d");
                        $hora_servidor_viajeTipo = date("H:i:s");
                        $codigo_off_line_viajeTipo = $viajeTipo["codigo_off_line"];
                        $tipo_viaje_viajeTipo = $viajeTipo["tipo_viaje"];
                        $fecha_registro_viajeTipo = $viajeTipo["fecha_registro"];
                        $latitud_viajeTipo = empty($viajeTipo["latitud"]) ? null : $viajeTipo["latitud"];
                        $longitud_viajeTipo = empty($viajeTipo["longitud"]) ? null : $viajeTipo["longitud"];
                        $numero_ocupantes_viajeTipo = $viajeTipo["numero_ocupantes"];
                        $placa_viajeTipo = $viajeTipo["placa"];
                        $timestamp_servidor_viajeTipo = "$fecha_servidor_viajeTipo $hora_servidor_viajeTipo";

                        if($codigo_off_line == $codigo_off_line_viajeTipo){
                            $sql = "INSERT INTO viaje_tipo(codigo_viaje,
                                                            codigo_off_line,
                                                            tipo_viaje,
                                                            fecha_registro_dispositivo,
                                                            fecha_registro_servidor,
                                                            latitud,
                                                            longitud,
                                                            numero_ocupantes,
                                                            placa)
                                                values (:codigo_viaje,
                                                        :codigo_off_line,
                                                        :tipo_viaje,
                                                        :fecha_registro_dispositivo,
                                                        :fecha_registro_servidor,
                                                        :latitud,
                                                        :longitud,
                                                        :numero_ocupantes,
                                                        :placa);";
                            $sentencia = $this->dblink->prepare($sql);
                            $sentencia->bindParam(":codigo_viaje", $codigo_viaje);
                            $sentencia->bindParam(":codigo_off_line", $codigo_off_line_viajeTipo);
                            $sentencia->bindParam(":tipo_viaje", $tipo_viaje_viajeTipo);
                            $sentencia->bindParam(":fecha_registro_servidor", $timestamp_servidor_viajeTipo);
                            $sentencia->bindParam(":fecha_registro_dispositivo", $fecha_registro_viajeTipo);
                            $sentencia->bindParam(":latitud", $latitud_viajeTipo);
                            $sentencia->bindParam(":longitud", $longitud_viajeTipo);
                            $sentencia->bindParam(":numero_ocupantes", $numero_ocupantes_viajeTipo);
                            $sentencia->bindParam(":placa", $placa_viajeTipo);
                            $sentencia->execute();
                        }
                    }

                    foreach($viajeEmpleadoDetalle as $viajeEmpleado){
                        $fecha_servidor_viajeEmpleado = date("Y-m-d");
                        $hora_servidor_viajeEmpleado = date("H:i:s");
                        $tipo_viaje_viajeEmpleado = $viajeEmpleado["tipo_viaje"];
                        $codigo_empresa_viajeEmpleado = $viajeEmpleado["codigo_empresa"];
                        $codigo_off_line_viajeEmpleado = $viajeEmpleado["codigo_off_line"];
                        $documento_empleado_viajeEmpleado = strlen($viajeEmpleado["documento_empleado"]) > 15 ? substr($viajeEmpleado["documento_empleado"], 0, 15) : $viajeEmpleado["documento_empleado"];
                        $nombre_empleado_viajeEmpleado = $viajeEmpleado["nombre_empleado"];
                        $codigo_tipo_mano_obra_viajeEmpleado = $viajeEmpleado["codigo_tipo_mano_obra"];
                        $tipo_mano_obra_viajeEmpleado = empty($viajeEmpleado["tipo_mano_obra"]) ? null : $viajeEmpleado["tipo_mano_obra"];
                        $fecha_registro_viajeEmpleado = $viajeEmpleado["fecha_registro"];
                        $estado_viajeEmpleado = $viajeEmpleado["estado"];
                        $latitud = empty($viajeEmpleado["latitud"]) ? null : $viajeEmpleado["latitud"];
                        $longitud = empty($viajeEmpleado["longitud"]) ? null : $viajeEmpleado["longitud"];
                        $timestamp_servidor_viajeEmpleado = "$fecha_servidor_viajeEmpleado $hora_servidor_viajeEmpleado";
                        $codigo_proveedor_empresa_ViajeEmpleado = isset($viajeEmpleado["codigo_proveedor_empresa"]) ? $viajeEmpleado["codigo_proveedor_empresa"] : 0;

                        $nombre = $this->encontrarNombreEmpleado($documento_empleado_viajeEmpleado, $codigo_empresa_viajeEmpleado);
                        $nombre_empleado_viajeEmpleado = $nombre["apellido_paterno"]." ". $nombre["apellido_materno"]. " ". $nombre["nombre"];

                        if($codigo_off_line == $codigo_off_line_viajeEmpleado){
                            $sql = "INSERT INTO viaje_empleado(codigo_viaje,
                                                            tipo_viaje,
                                                            codigo_off_line,
                                                            numero_documento,
                                                            nombre_empleado,
                                                            codigo_tipo_mano_obra,
                                                            tipo_mano_obra,
                                                            estado,
                                                            fecha_registro_dispositivo,
                                                            fecha_registro_servidor,
                                                            latitud,
                                                            longitud,
                                                            codigo_proveedor_empresa)
                                                values (:codigo_viaje,
                                                        :tipo_viaje,
                                                        :codigo_off_line,
                                                        :numero_documento,
                                                        :nombre_empleado,
                                                        :codigo_tipo_mano_obra,
                                                        :tipo_mano_obra,
                                                        :estado,
                                                        :fecha_registro_dispositivo,
                                                        :fecha_registro_servidor,
                                                        :latitud,
                                                        :longitud,
                                                        :codigo_proveedor_empresa);";
                            $sentencia = $this->dblink->prepare($sql);
                            $sentencia->bindParam(":codigo_viaje", $codigo_viaje);
                            $sentencia->bindParam(":codigo_off_line", $codigo_off_line_viajeEmpleado);
                            $sentencia->bindParam(":tipo_viaje", $tipo_viaje_viajeEmpleado);
                            $sentencia->bindParam(":numero_documento", $documento_empleado_viajeEmpleado);
                            $sentencia->bindParam(":nombre_empleado", $nombre_empleado_viajeEmpleado);
                            $sentencia->bindParam(":codigo_tipo_mano_obra", $codigo_tipo_mano_obra_viajeEmpleado);
                            $sentencia->bindParam(":tipo_mano_obra", $tipo_mano_obra_viajeEmpleado);
                            $sentencia->bindParam(":estado", $estado_viajeEmpleado);
                            $sentencia->bindParam(":fecha_registro_servidor", $timestamp_servidor_viajeEmpleado);
                            $sentencia->bindParam(":fecha_registro_dispositivo", $fecha_registro_viajeEmpleado);
                            $sentencia->bindParam(":latitud", $latitud);
                            $sentencia->bindParam(":longitud", $longitud);
                            $sentencia->bindParam(":codigo_proveedor_empresa", $codigo_proveedor_empresa_ViajeEmpleado);
                            $sentencia->execute();
                        }
                    }
                }
            }
            $sql = "SELECT * from viaje where codigo_off_line = ?";
            $sentencia = $this->dblink->prepare($sql);
            $sentencia->bindParam(1, $codigo_off_line_consulta);
            $sentencia->execute();

            if (!$sentencia->rowCount()) {
                return [];
            }

            $resultado = $sentencia->fetchAll(PDO::FETCH_ASSOC);
            foreach($resultado as $item){
                $codigo_viaje = $item["codigo_viaje"];
                $sql = "SELECT * from viaje_tipo where codigo_off_line = ?";
                $sentencia = $this->dblink->prepare($sql);
                $sentencia->bindParam(1, $codigo_off_line_consulta);
                $sentencia->execute();

                if($sentencia->rowCount()){
                    $item["viajeTipo"] = $sentencia->fetchAll(PDO::FETCH_ASSOC);
                }else{
                    $item["viajeTipo"] = [];
                }

                $sql = "SELECT * from viaje_empleado where codigo_off_line = ?";
                $sentencia = $this->dblink->prepare($sql);
                $sentencia->bindParam(1, $codigo_off_line_consulta);
                $sentencia->execute();

                if($sentencia->rowCount()){
                    $item["viajeEmpleado"] = $sentencia->fetchAll(PDO::FETCH_ASSOC);
                }else{
                    $item["viajeEmpleado"] = [];
                }
                $arrayResultado[] = $item;
            }
            $this->dblink->commit();
            return $arrayResultado;
        } catch (Exception $e) {
            throw $e;
        }
    }

    public function encontrarNombreEmpleado($dni, $codigo_empresa)
    {
        $sql = "SELECT
                    e.*,
                    (
                        coalesce(
                            (select estado from empleado_empresa where codigo_empleado = e.codigo_empleado and codigo_empresa = $codigo_empresa limit 1),
                            'E'
                            )
                        ) as estado
                FROM
                    empleado as e
                WHERE
                    numero_documento = ?;";

        //Estado E -> Empty state / vacío -> entonces hacer la consulta para poder agregarlo a esa relacion 'empleado_empresa'
        $sentencia = $this->dblink->prepare($sql);
        $sentencia->bindParam(1, $dni);
        $sentencia->execute();
        if(!$sentencia->rowCount()){
            $json = '{CODDNI: "' . $dni . '"}';
            $ch = curl_init();
            curl_setopt($ch, CURLOPT_URL, CONSULTA_JNE);
            curl_setopt($ch, CURLOPT_POST, 1);
            curl_setopt($ch, CURLOPT_POSTFIELDS, $json);
            curl_setopt($ch, CURLOPT_HEADER, TRUE);
            curl_setopt($ch, CURLOPT_HTTPHEADER, array("Content-Type: application/json", "RequestVerificationToken: " . TOKEN_JNE));
            curl_setopt($ch, CURLOPT_RETURNTRANSFER, TRUE);

            $head = curl_exec($ch);
            curl_close($ch);

            $porciones = explode("GMT", $head);
            $ultimo_elemento = count($porciones) - 1;
            $respuesta = json_decode($porciones[$ultimo_elemento], TRUE);

            if (isset($respuesta["data"])) {
                $respuesta = explode("|", $respuesta["data"]);

                if ($respuesta[0] == "" && $respuesta[1] == "" && $respuesta[2] == "") {
                    /* Si no fue encontrado en RENIEC se regresa un array vacío */
                    $resultado = $this->personalNuevo();
                    /* Si no fue encontrado en RENIEC se regresa un array vacío */
                } else {
                    $resultado["apellido_paterno"] = $respuesta[0];
                    $resultado["apellido_materno"] = $respuesta[1];
                    $resultado["nombre"] = $respuesta[2];

                    $sql = "SELECT numero + 1 as nc from correlativo_control where tabla = 'empleado';";
                    $sentencia = $this->dblink->prepare($sql);
                    $sentencia->execute();

                    if (!$sentencia->rowCount()) {
                        $sql = "INSERT into correlativo_control(numero, tabla) values(0, 'empleado');";
                        $sentencia = $this->dblink->prepare($sql);
                        $sentencia->execute();
                        $codigo_empleado = 1;
                    } else {
                        $rep = $sentencia->fetch(PDO::FETCH_ASSOC);
                        $codigo_empleado = $rep["nc"];
                    }
                    $sql = "INSERT into empleado(codigo_empleado, numero_documento, nombre, apellido_paterno, apellido_materno)
                                        values(?, ?, ?, ?, ?);";
                    $sentencia = $this->dblink->prepare($sql);
                    $sentencia->bindParam(1, $codigo_empleado);
                    $sentencia->bindParam(2, $dni);
                    $sentencia->bindParam(3, $resultado["nombre"]);
                    $sentencia->bindParam(4, $resultado["apellido_paterno"]);
                    $sentencia->bindParam(5, $resultado["apellido_materno"]);
                    $sentencia->execute();

                    $sql = "UPDATE correlativo_control set numero= numero + 1 where tabla = 'empleado'";
                    $sentencia = $this->dblink->prepare($sql);
                    $sentencia->execute();

                    $resultado["codigo_empleado"] = $codigo_empleado;

                    $estado = "A";
                    $sql = "INSERT INTO empleado_empresa values(?, ? ,?);";
                    $sentencia = $this->dblink->prepare($sql);
                    $sentencia->bindParam(1, $resultado["codigo_empleado"]);
                    $sentencia->bindParam(2, $codigo_empresa);
                    $sentencia->bindParam(3, $estado);
                    $sentencia->execute();
                    $resultado["estado"] = $estado;
                }
            } else {
                //NO ENCONTRADO
                $resultado = $this->personalNuevo();
            }
        }else{
            $resultado = $sentencia->fetch(PDO::FETCH_ASSOC);
            if($resultado["estado"] == "E"){
                $estado = "A";
                $sql = "INSERT INTO empleado_empresa values(?, ? ,?);";
                $sentencia = $this->dblink->prepare($sql);
                $sentencia->bindParam(1, $resultado["codigo_empleado"]);
                $sentencia->bindParam(2, $codigo_empresa);
                $sentencia->bindParam(3, $estado);
                $sentencia->execute();
                $resultado["estado"] = $estado;
            }
        }
        return $resultado;
    }

    public function personalNuevo()
    {
        $resultado["codigo_empleado"] = 0;
        $resultado["nombre"] = "PERSONAL NUEVO";
        $resultado["apellido_paterno"] = "";
        $resultado["apellido_materno"] = "";
        return $resultado;
    }

    public function sincronizarEmpleados()
    {
        $this->dblink->beginTransaction();
        try {
            $sql = "SELECT DISTINCT codigo_empresa from viaje;";
            $sentencia = $this->dblink->prepare($sql);
            $sentencia->execute();
            $respuesta = $sentencia->fetchAll(PDO::FETCH_ASSOC);
            foreach($respuesta as $rep){
                $codigo_empresa = $rep["codigo_empresa"];
                $sql = "SELECT DISTINCT
                                ve.numero_documento
                        from viaje_empleado as ve
                            inner join viaje as v on(ve.codigo_viaje = v.codigo_viaje)
                        where v.codigo_empresa = ?";
                $sentencia = $this->dblink->prepare($sql);
                $sentencia->bindParam(1, $codigo_empresa);
                $sentencia->execute();
                $resultados = $sentencia->fetchAll(PDO::FETCH_ASSOC);
                foreach($resultados as $resultado){
                    $numero_documento = $resultado["numero_documento"];
                    $this->encontrarNombreEmpleado($numero_documento, $codigo_empresa);
                }
            }
            $this->dblink->commit();
            return true;
        } catch (Exception $e) {
            throw $e;
        }
    }
}